export declare const noOpTag: (strings: TemplateStringsArray, ...exps: string[]) => string;
export declare const gql: (strings: TemplateStringsArray, ...exps: string[]) => string;
export declare type Fetch = (url: RequestInfo, init?: RequestInit) => Promise<Response>;
export declare type ApiOptions = {
    wsUrl?: string;
    headers?: object;
    fetch?: Fetch;
    onError?: (msg: string, err: Error) => void;
};
export declare type Subscription = {
    onData: (handler: SubscriptionDataHandler) => Subscription;
    close: () => void;
};
export declare type SubscriptionDataHandler = (data: any) => any;
export declare class Api {
    url: string;
    wsUrl: string;
    fetch: Fetch;
    headers: object;
    socket: Socket;
    onError: (msg: string, err?: Error) => void;
    constructor(url: string, apiOptions?: string | ApiOptions);
    get log(): (msg: string) => void;
    set log(fn: (msg: string) => void);
    run(query: string, variables?: object): Promise<any>;
    subscribe(query: string, variables?: object, channelName?: string): Subscription;
}
export declare type SocketSubscription = {
    dataHandler?: (data: any) => any;
};
declare class Socket {
    log: (msg: string) => void;
    webSocket: WebSocket;
    subscriptions: {
        [id: string]: SocketSubscription;
    };
    connected: boolean;
    connectedHandlers: Array<() => void>;
    constructor(wsUrl: string, headers?: object, onConnected?: () => void);
}
export {};
